function geotiffclone(georef_file,geocloned_file,image)

% 23/12/2012 - Version 1.0
% 23/12/2012 - Version 1.6 / Forces RasterPixelIsArea to GTRasterTypeGeoKey

% Reads the georeference from tiff file [georef_file], then writes image
% [image] with the georeference of the [georef_file].

% Consider you have a georeferenced image A and you have created a
% processed image B = f(A). If you want to write the image B and keep the
% geoinfo of A, you may use this function as follows:

% geotiffclone( filename(A), filename(B), B ) 

% Author: Aristides D. Vaiopoulos

% Read geotiffinfo
gti         = geotiffinfo(georef_file);
R           = gti.RefMatrix;
GTT_GKDT    = gti.GeoTIFFTags.GeoKeyDirectoryTag;
% Force RasterPixelIsArea
GTT_GKDT.GTRasterTypeGeoKey = 1;

geotiffwrite( geocloned_file,image,R,'GeoKeyDirectoryTag',GTT_GKDT)

end