function [array_without_infs inf_q inf_index] = infkill(array_with_infs,...
                                                elimination_value,verbosity)

% N-D (+-)Inf Killer

% 24/11/2010 - Version 1.0
% 23/12/2012 - Version 2.0

% Author: Aristides D. Vaiopoulos

if nargin == 1
    elimination_value = 0;
    verbosity = 0;
end
if nargin == 2
    verbosity = 0;
end
% Prepare inf-free array
array_without_infs = array_with_infs;
% Construct index logical array 
inf_index = isinf(array_with_infs);
array_without_infs(inf_index) = elimination_value;
% inf_q = inf quantity
inf_q = sum(reshape(inf_index,[numel(inf_index) 1]));

if verbosity == 1 && inf_q > 0
    disp(' ')
    disp(['Inf Killer: Eliminated ',num2str(inf_q),' values with ',...
                                     num2str(elimination_value),'.'])
    disp(' ')
end

end

